(*
  DTween

  The MIT License

  Copyright (c) 2011 Lyna, http://twc.xrea.jp/

  Permission is hereby granted, free of charge, to any person obtaining a copy
  of this software and associated documentation files (the "Software"), to deal
  in the Software without restriction, including without limitation the rights
  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  copies of the Software, and to permit persons to whom the Software is
  furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included in
  all copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
  THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
  THE SOFTWARE.

  ----------

  XV

    Ver.0.1  11/08/09  *

    Ver.0.2  11/08/11  *TTweenSerial, Parallel, Delay

    Ver.0.3  11/08/12  *TTween.Abort
                       *TColor^vpeBɑΉ
                       *eTween\bh̕p[^ł

    Ver.0.4  11/08/13  *Overwrite@\

    Ver.0.5  11/08/14  *Ύw莞From, Tȍȗ̃vpeBl擾
                       uTween\bhR[_v
                       u߂ăgDC[sꂽ_vɎdlύX
                       *Duration1t[̎ԂɖȂgDC[
                        SerialɒǉۂɁAő2̃gDC[sȂ
                        sC
                       *TTweenCycle\bhǉ

    Ver.0.6  11/08/17  *蓮ɂgDC[̍XVɑΉ(AutoUpdatevpeB)
                       *^vpeBɑΉ
                       *TTween.Tween(To,From)\bhŕ̃CX^XxɎw\
                       *TTween.Tween(To,From)\bh̒Pp[^łp~

    Ver.0.7  11/08/18  *gDC[sĂȂƂ
                        ^C}[~߂悤ɂ

    Ver.0.8  11/08/19  *2009ȑÕo[WɑΉ(ꕔ)

    Ver.0.9  11/08/24  *Int64^̃vpeBɑΉ
                       *2006`2009ŃRpCw߂ԈĂ̂C
                       *vpeB̏TypInfoSetXXXXProp֐ɓ
*)
unit DTween;

interface

{$I DTweenCompilerDefines.inc}

uses
  Windows, SysUtils, Classes, MMSystem, TypInfo, StdCtrls,
{$IFNDEF USECLASSSYNCHRONIZE}
  ExtCtrls,
{$ENDIF}
{$IFDEF USEGENERIC}
  Generics.Collections,
{$ENDIF}
{$IFDEF USERTTI}
  Rtti,
{$ENDIF}
{$IFDEF USENAMESPACE}
  DTween.Easing;
{$ELSE}
  DTweenEasing;
{$ENDIF}

type
  ETweenException = class(Exception);
  ITween = interface;

  { gDC[Cxgp̃\bhQ
    \bhȊÔ(ʂ̃\bh葱)荞߂܂
    2009Õo[Wł̓\bĥݎwł܂ }
{$IFDEF USEANONYMOUSMETHOD}
  TTweenEventProc = reference to procedure(Sender: ITween);
{$ELSE}
  TTweenEventProc = procedure(Sender: ITween) of object;
{$ENDIF}

  { gDC[̓𐧌䂷C^[tF[Xł
    C^[tF[XȂ̂ŁAzQƂɂCtΉ̎Ԃ͂܂ }
  ITween = interface

    { gDC[̓܂ }
    procedure Initialize;

    { gDC[Đ܂
      ĐI(IsCompleted=True)ōēxĂԂƏčĐ܂ }
    procedure Play;

    { gDC[ꎞ~܂
      PlayōĊJ܂}
    procedure Pause;

    { gDC[~܂ }
    procedure Stop;

    { vpeB̒ľ݂oߎԂɉčXVA]ԂԂ܂
      IɎg܂ }
    function Update(const DeltaTime: Cardinal): Cardinal;

    function GetPosition: Cardinal;
    function GetDuration: Cardinal;
    function GetOverwrite: Boolean;
    procedure SetOverwrite(const Value: Boolean);
    function GetStopOnComplete: Boolean;
    procedure SetStopOnComplete(const Value: Boolean);
    function GetIsPaused: Boolean;
    function GetIsCompleted: Boolean;
    function GetOnUpdate: TTweenEventProc;
    procedure SetOnUpdate(const Value: TTweenEventProc);
    function GetOnComplete: TTweenEventProc;
    procedure SetOnComplete(const Value: TTweenEventProc);

    { ݂̍Đʒu擾܂ }
    property Position: Cardinal read GetPosition;

    { Đ̌pԂ擾܂ }
    property Duration: Cardinal read GetDuration;

    { ɎsĂgDC[̓㏑邩ǂw肵܂
      TruȅꍇAgDC[̑ΏۂƂȂCX^X̃gDC[~܂
      Falsȅꍇ͐ɎsĂgDC[ɑ΂ĉ܂
      Truew肵ۂ̃gDC[̒~Playɍs邽߁A
      łɎs̃gDC[ɑ΂Đݒ肵Ăɔf܂
      ftHglTTween.DefaultOverwritevpeBɈˑ܂ }
    property Overwrite: Boolean read GetOverwrite write SetOverwrite;

    { gDC[̓w肵܂
      TruȅꍇA1xĐ܂
      FalsȅꍇAlɖ߂ČJԂĐ܂
      ftHgTrueł
      SerialDelayŃbvꍇAbvꂽgDC[͎TrueɂȂ܂ }
    property StopOnComplete: Boolean read GetStopOnComplete write SetStopOnComplete;

    { gDC[ꎞ~ĂꍇTrueԂ܂ }
    property IsPaused: Boolean read GetIsPaused;

    { gDC[̓삪ĂꍇTrueԂ܂ }
    property IsCompleted: Boolean read GetIsCompleted;

    { gDC[ŒlXVxɌĂԏw肵܂ }
    property OnUpdate: TTweenEventProc read GetOnUpdate write SetOnUpdate;

    { gDC[ɌĂԏw肵܂
      StopOnCompleteFalsȅꍇA삪xɃR[܂ }
    property OnComplete: TTweenEventProc read GetOnComplete write SetOnComplete;
  end;

{$IFDEF USEGENERIC}
  TTweenList = TList<ITween>;
  TObjectTweenDictionary = class(TObjectDictionary<TObject,TList<ITween>>)
  public
    constructor Create;
  end;
{$ELSE}
  TCollectionNotification = (cnAdded, cnExtracted, cnRemoved);

  TListNotifyEvent = procedure(Sender: TObject; const Item: ITween;
    Action: TCollectionNotification) of object;

  TTweenList = class
  private
    FList: TList;
    FOnNotify: TListNotifyEvent;
    function GetCount: Integer;
    function GetItem(Index: Integer): ITween;
  protected
    procedure Notify(const Item: ITween; Action: TCollectionNotification);
  public
    constructor Create;
    destructor Destroy; override;
    function Add(const Item: ITween): Integer;
    procedure Delete(Index: Integer);
    function Remove(const Item: ITween): Integer;
    function Contains(const Item: ITween): Boolean;

    property Count: Integer read GetCount;
    property Items[Index: Integer]: ITween read GetItem; default;
    property OnNotify: TListNotifyEvent read FOnNotify write FOnNotify;
  end;

  TKeyValue = record
    Key: TObject;
    Value: TTweenList;
  end;
  PKeyValue = ^TKeyValue;

  TObjectTweenDictionary = class
  private
    FList: TList;
    function GetCount: Integer;
    function GetItem(const Key: TObject): TTweenList;
  public
    constructor Create;
    destructor Destroy; override;
    procedure Clear;
    procedure Add(const Key: TObject; const Value: TTweenList);
    procedure Delete(Index: Integer);
    procedure Remove(const Key: TObject);
    function IndexOf(const Item: TObject): Integer;
    function ContainsKey(const Key: TObject): Boolean;
    function TryGetValue(const Key: TObject; out Value: TTweenList): Boolean;
    property Items[const Key: TObject]: TTweenList read GetItem; default;
    property Count: Integer read GetCount;
  end;
{$ENDIF}

  TUpdateProc = {$IFDEF USEANONYMOUSMETHOD}TProc{$ELSE}procedure of object{$ENDIF};

  { gDC[̋N_ƂȂNXł
    CX^XɎg܂(Ă͂Ȃł) }
  TTween = class
  private
{$IFDEF USECLASSPROPERTY}
    const
      DEFAULT_SPEED = 30;
    class var
      FList: TTweenList;
      FObjTweens: TObjectTweenDictionary;
{$IFDEF USECLASSSYNCHRONIZE}
      FTimerId: MMRESULT;
{$ELSE}
      FTimer: TTimer;
{$ENDIF}
      FPrevTime: Cardinal;
      FDefaultOverwrite: Boolean;
      FAutoUpdate: Boolean;
      FSpeed: Cardinal;
      FOnBeforeUpdate: TUpdateProc;
      FOnAfterUpdate: TUpdateProc;
{$ENDIF}      
    class procedure AddToPlayList(Obj: TObject; Tween: ITween);
    class procedure RemoveFromPlayList(Obj: TObject; Tween: ITween);
{$IFNDEF USECLASSSYNCHRONIZE}
    class procedure OnTimer(Sender: TObject);
{$ENDIF}
    class procedure StartTimer;
    class procedure ClearTimer;
    class procedure ListNotify(Sender: TObject; const Item: ITween; Action: TCollectionNotification);
{$IFDEF USECLASSPROPERTY}
    class procedure SetAutoUpdate(const Value: Boolean); {$IFDEF USESTATIC}static;{$ENDIF}
    class procedure SetSpeed(const Value: Cardinal); {$IFDEF USESTATIC}static;{$ENDIF}
{$ENDIF}
  public
    { w肵CX^XɊ֘A铮쒆̃gDC[SĒ~܂
      ȗꍇASĂ̓쒆̃gDC[~܂
      ܂PlayĂȂ́AStopĕʂ̕ϐŕێĂ̓͏܂ }
    class procedure Abort(Obj: TObject = nil);

    { gDC[̍XVs܂
      AutoUpdateTruȅꍇ͎ŌĂяo܂A
      Falsȅꍇ͒IɌĂяoKv܂ }
    class procedure Update;

    { gDC[쐬܂
      ߂lITweenŁAPlay\bhR[ƃgDC[Jn܂
      Obj:
        Ώۂ̃CX^Xw肵܂
      FromValues:
        lύXvpeB̏lw肵܂
        Βlw肵܂AvpeB'$'tꍇ
        gDC[̏s̃vpeBl̑ΒlɂȂ܂
        vpeBƒl݂ɋLq܂
        ex. Tween(Sender, ['$Left', -100, 'Top', 0], [], 500).Play;
      ToValues:
        lύXvpeB̏Ilw肵܂
        Βlw肵܂AvpeB'$'tꍇ
        gDC[̏s̃vpeBl̑ΒlɂȂ܂
        vpeBƒl݂ɋLq܂
        ex. Tween(Sender, [], ['$Left', 100, 'Top', 800], 500).Play;
      Duration:
        FromValuesToValuesɓB鎞Ԃw肵܂
        Pʂ̓~bł
      Easing:
        C[WO֐w肵܂(DTweenjbgTEasing̃\bh)
        ȗꍇATEasing.Lineargp܂ }
    class function Tween(const Obj: TObject; const FromValues, ToValues: array of const;
      const Duration: Cardinal; const Easing: IEasing = nil): ITween; overload;

    { Tween\bh̑ΏۃCX^X𕡐wło[Wł }
    class function Tween(const Objs: array of TObject; const FromValues, ToValues: array of const;
      const Duration: Cardinal; const Easing: IEasing = nil): ITween; overload;

    { Tween\bhFromValuesȗłł
      ̏ꍇFromValues̓gDC[Jn_̒lɂȂ܂ }
    class function TweenTo(Obj: TObject; const ToValues: array of const;
      Duration: Cardinal; const Easing: IEasing = nil): ITween; overload;

    { TweenTȏΏۃCX^X𕡐wło[Wł }
    class function TweenTo(const Objs: array of TObject; const ToValues: array of const;
      Duration: Cardinal; const Easing: IEasing = nil): ITween; overload;

    { Tween\bhToValueȗłł
      ̏ꍇToValue̓gDC[Jn_̒lɂȂ܂ }
    class function TweenFrom(Obj: TObject; const FromValues: array of const;
      Duration: Cardinal; const Easing: IEasing = nil): ITween; overload;

    { TweenFrom̑ΏۃCX^X𕡐wło[Wł }
    class function TweenFrom(const Objs: array of TObject; const FromValues: array of const;
      Duration: Cardinal; const Easing: IEasing = nil): ITween; overload;

    { ̃gDC[𒼗Ɍq܂ }
    class function Serial(const Tweens: array of ITween): ITween; {$IFDEF USESTATIC}static;{$ENDIF}

    { ̃gDC[Ɍq܂ }
    class function Parallel(const Tweens: array of ITween): ITween; {$IFDEF USESTATIC}static;{$ENDIF}

    { w肵gDC[̑OɃfBCt܂ }
    class function Delay(const PreDelay, PostDelay: Cardinal;
      const BaseTween: ITween): ITween; {$IFDEF USESTATIC}static;{$ENDIF}

    { gDC[w񐔌JԂ܂ }
    class function Cycle(const CycleCount: Cardinal;
      const BaseTween: ITween): ITween; {$IFDEF USESTATIC}static;{$ENDIF}

    { NXvpeBɑΉĂȂo[Wł͈ȉ̐ݒς܂
      ꉽƂłALq@Ɍ݊Ȃ̂ŔȂƂc }
{$IFDEF USECLASSPROPERTY}
    { egDC[OverwritevpeB̏l`܂
      DefaultOverwriteg̏lTrueł }
    class property DefaultOverwrite: Boolean read FDefaultOverwrite write FDefaultOverwrite;

    { gDC[̍XVTTweens蓮ōsw肵܂
      TruȅꍇATTween^C}[ŎIɍXVs܂(ftHg)
      FalsȅꍇACӂ̃^C~OŃ[U[TTween.UpdateĂяočXV܂ }
    class property AutoUpdate: Boolean read FAutoUpdate write SetAutoUpdate;

    { 1bԂ̍XV񐔂w肵܂
      LȒl1`1000ł(A60𒴂Ƃ܂ӖC܂) }
    class property Speed: Cardinal read FSpeed write SetSpeed;

    { et[ŃgDC[s钼OɌĂ΂Cxgł }
    class property OnBeforeUpdate: TUpdateProc read FOnBeforeUpdate write FOnBeforeUpdate;

    { et[ŃgDC[sꂽɌĂ΂Cxgł }
    class property OnAfterUpdate: TUpdateProc read FOnAfterUpdate write FOnAfterUpdate;
{$ENDIF}
  end;

implementation

uses Math;

{$IFDEF USEGENERIC}

{ TObjectTweenDictionary }

constructor TObjectTweenDictionary.Create;
begin
  inherited Create([doOwnsValues]);
end;

{$ELSE}

{ TTweenList }

constructor TTweenList.Create;
begin
  FList := TList.Create;
end;

destructor TTweenList.Destroy;
begin
  while Count > 0 do
    Delete(Count-1);
  FList.Free;
  inherited;
end;

function TTweenList.Add(const Item: ITween): Integer;
begin
  Result := FList.Add(nil);
  ITween(FList.List[Result]) := Item;
  Notify(Item, cnAdded);
end;

procedure TTweenList.Delete(Index: Integer);
var
  temp: ITween;
begin
  temp := ITween(FList[Index]);
  ITween(FList.List[Index]) := nil;
  FList.Delete(Index);
  if temp <> nil then
    Notify(temp, cnRemoved);
end;

function TTweenList.Remove(const Item: ITween): Integer;
begin
  Result := FList.IndexOf(Pointer(Item));
  if Result >= 0 then
  begin
    Delete(Result);
    Notify(Item, cnRemoved);
  end;
end;

function TTweenList.Contains(const Item: ITween): Boolean;
begin
  Result := FList.IndexOf(Pointer(Item)) >= 0;
end;

function TTweenList.GetCount: Integer;
begin
  Result := FList.Count;
end;

function TTweenList.GetItem(Index: Integer): ITween;
begin
  Result := ITween(FList[Index]);
end;

procedure TTweenList.Notify(const Item: ITween; Action: TCollectionNotification);
begin
  if Assigned(FOnNotify) then
    FonNotify(Self, Item, Action);
end;

{ TObjectTweenDictionary }

constructor TObjectTweenDictionary.Create;
begin
  FList := TList.Create;
end;

destructor TObjectTweenDictionary.Destroy;
begin
  Clear;
  FList.Free;
  inherited;
end;

procedure TObjectTweenDictionary.Clear;
begin
  while Count > 0 do
    Delete(Count-1);
  FList.Clear;
end;

procedure TObjectTweenDictionary.Add(const Key: TObject; const Value: TTweenList);
var
  p: PKeyValue;
begin
  New(p);
  p^.Key := Key;
  p^.Value := Value;
  FList.Add(p);
end;

procedure TObjectTweenDictionary.Delete(Index: Integer);
var
  p: PKeyValue;
begin
  p := PKeyValue(FList[Index]);
  p^.Value.Free;
  Dispose(p);
  FList.Delete(Index);
end;

procedure TObjectTweenDictionary.Remove(const Key: TObject);
var
  i: Integer;
begin
  i := IndexOf(Key);
  if i >= 0 then
    Delete(i);
end;

function TObjectTweenDictionary.IndexOf(const Item: TObject): Integer;
begin
  Result := 0;
  while (Result < Count) and (PKeyValue(FList[Result])^.Key <> Item) do
    Inc(Result);
  if Result = Count then
    Result := -1;
end;

function TObjectTweenDictionary.ContainsKey(const Key: TObject): Boolean;
begin
  Result := IndexOf(Key) >= 0;
end;

function TObjectTweenDictionary.TryGetValue(const Key: TObject; out Value: TTweenList): Boolean;
var
  i: Integer;
begin
  i := IndexOf(Key);
  Result := i >= 0;
  if Result then
    Value := PKeyValue(FList[i])^.Value;
end;

function TObjectTweenDictionary.GetCount: Integer;
begin
  Result := FList.Count;
end;

function TObjectTweenDictionary.GetItem(const Key: TObject): TTweenList;
var
  i: Integer;
begin
  i := IndexOf(Key);
  if i >= 0 then
    Result := PKeyValue(FList[i])^.Value
  else
    Result := nil;
end;

{$ENDIF}

{$IFNDEF USECLASSPROPERTY}
const
  DEFAULT_SPEED = 30;
var
  FList: TTweenList;
  FObjTweens: TObjectTweenDictionary;
{$IFDEF USECLASSSYNCHRONIZE}
  FTimerId: MMRESULT;
{$ELSE}
  FTimer: TTimer;
{$ENDIF}
  FPrevTime: Cardinal;
  FDefaultOverwrite: Boolean;
  FAutoUpdate: Boolean;
  FSpeed: Cardinal;
  FOnBeforeUpdate: procedure of object;
  FOnAfterUpdate: procedure of object;
{$ENDIF}

{$IFNDEF USEINTASOBJ}
{$I IntfAsObj.inc}
{$ENDIF}

function IntfAsObj(const I: IInterface): TObject;{$IFDEF USEINLINE}inline;{$ENDIF}
begin
{$IFDEF USEINTFASOBJ}
  Result := I as TObject;
{$ELSE}
  Result := GetImplementingObject(I);
{$ENDIF}
end;

{ TAbstractTween }

type
  TAbstractTween = class(TInterfacedObject, ITween)
  private
    FParent: TAbstractTween;
    FIsPaused: Boolean;
    FOverwrite: Boolean;
    FStopOnComplete: Boolean;
    FOnUpdate: TTweenEventProc;
    FOnComplete: TTweenEventProc;
    procedure SetParent(const Value: TAbstractTween);
    function GetPosition: Cardinal;
    function GetDuration: Cardinal;
    function GetOverwrite: Boolean;
    procedure SetOverwrite(const Value: Boolean);
    function GetStopOnComplete: Boolean;
    procedure SetStopOnComplete(const Value: Boolean);
    function GetIsPaused: Boolean;
    function GetIsCompleted: Boolean;
    function GetOnUpdate: TTweenEventProc;
    procedure SetOnUpdate(const Value: TTweenEventProc);
    function GetOnComplete: TTweenEventProc;
    procedure SetOnComplete(const Value: TTweenEventProc);
  protected
    FPosition: Cardinal;
    FDuration: Cardinal;
    procedure AddToPlayList(Tween: ITween); virtual;
    procedure RemoveFromPlayList(Tween: ITween); virtual;
    procedure DoOverwrite; virtual;
    property Parent: TAbstractTween read FParent write SetParent;
  public
    constructor Create;
    procedure Initialize; virtual; abstract;
    procedure Play;
    procedure Pause;
    procedure Stop;
    procedure DoUpdate(const DeltaTime: Cardinal); virtual; abstract;
    function Update(const DeltaTime: Cardinal): Cardinal;

    property Position: Cardinal read GetPosition;
    property Duration: Cardinal read GetDuration;
    property Overwrite: Boolean read GetOverwrite write SetOverwrite;
    property StopOnComplete: Boolean read GetStopOnComplete write SetStopOnComplete;
    property IsPaused: Boolean read GetIsPaused;
    property IsCompleted: Boolean read GetIsCompleted;
    property OnComplete: TTweenEventProc read GetOnComplete write SetOnComplete;
  end;

  TPropType = (ptInteger, ptColor, ptFloat, ptInt64);
  TPropValue = record
    case TPropType of
      ptInteger: (AsInteger: Integer);
      ptColor: (AsColor: Integer);
      ptFloat: (AsFloat: Extended);
      ptInt64: (AsInt64: Int64);
  end;
  TDiffValue = record
    case TPropType of
      ptInteger: (AsInteger: Integer);
      ptColor: (AsColor: array[0..2] of Integer);
      ptFloat: (AsFloat: Extended);
      ptInt64: (AsInt64: Int64);
  end;
  // MEMO: ȂTInitValueTChangeValue̗ŏl邩ƂƁA
  // TInitValueValueTween\bhœnꂽ̂܂܂̏lȂ̂ɑ΂āA
  // TChangeValueBaseValue͌vẐ߂ɃVXeJ[GetSysColor̂ێĂ邽
  // TChangeValue.FinishValue݂闝R
  TInitValue = record
    Prop: PPropInfo;
    IsRelative: Boolean;
    PropType: TPropType;
    Value: TPropValue;
  end;
  TChangeValue = record
    Prop: PPropInfo;
    IsRelative: Boolean;
    BaseValue: TPropValue;
    FinishValue: TPropValue;
    PropType: TPropType;
    DiffValue: TDiffValue;
  end;

  TObjectTween = class(TAbstractTween)
  private
    FObj: TObject;
    FEasing: IEasing;
    FIsValueFixed: Boolean;
    FInitValues: array of TInitValue;
    FChangeValues: array of TChangeValue;

    procedure CalcValues;
    function GetProperty({$IFDEF USERTTI}const RttiType: TRttiType;{$ENDIF}const Obj: TObject; const PropName: string;
      out IsRelative: Boolean; out PropType: TPropType): PPropInfo;
    function GetPropAbsoluteValue(const Obj: TObject; const Prop: PPropInfo;
      const BaseValue: TPropValue): TPropValue;
  protected
    procedure AddToPlayList(Tween: ITween); override;
    procedure RemoveFromPlayList(Tween: ITween); override;
    procedure DoOverwrite; override;
  public
    constructor Create(const Obj: TObject; const FromValues, ToValues: array of const;
      const Duration: Cardinal; const Easing: IEasing);
    procedure Initialize; override;
    procedure DoUpdate(const DeltaTime: Cardinal); override;
  end;

  // q̃gDC[NX͑Sh
  TWrapTween = class(TAbstractTween)
  private
    function GetBaseTween: ITween; {$IFDEF USEINLINE}inline;{$ENDIF}
  protected
    FTweens: array of ITween;
    procedure AddToPlayList(Tween: ITween); override;
    procedure RemoveFromPlayList(Tween: ITween); override;
    procedure DoOverwrite; override;
  public
    constructor Create(const Tweens: array of ITween); overload;
    constructor Create(const BaseTween: ITween); overload;
    property BaseTween: ITween read GetBaseTween;
  end;

  TParallelTween = class(TWrapTween)
  public
    constructor Create(const Tweens: array of ITween);
    procedure Initialize; override;
    procedure DoUpdate(const DeltaTime: Cardinal); override;
  end;

  TSerialTween = class(TWrapTween)
  private
    FTweenIndex: Integer;
  public
    constructor Create(const Tweens: array of ITween);
    procedure Initialize; override;
    procedure DoUpdate(const DeltaTime: Cardinal); override;
  end;

  TDelayedTween = class(TWrapTween)
  private
    FPreDelay: Cardinal;
    FPostDelay: Cardinal;
    FState: (Pre, Proc, Post);
  public
    constructor Create(const PreDelay, PostDelay: Cardinal; const BaseTween: ITween);
    procedure Initialize; override;
    procedure DoUpdate(const DeltaTime: Cardinal); override;
  end;

  TCycledTween = class(TWrapTween)
  private
    FCurrentCount: Cardinal;
    FCycleCount: Cardinal;
  public
    constructor Create(const CycleCount: Cardinal; const BaseTween: ITween);
    procedure Initialize; override;
    procedure DoUpdate(const DeltaTime: Cardinal); override;
  end;

constructor TAbstractTween.Create;
begin
  FIsPaused := True;
  FStopOnComplete := True;
{$IFDEF USECLASSPROPERTY}
  FOverwrite := TTween.DefaultOverwrite;
{$ELSE}
  FOverwrite := FDefaultOverwrite;
{$ENDIF}
end;

procedure TAbstractTween.AddToPlayList(Tween: ITween);
begin
end;

procedure TAbstractTween.RemoveFromPlayList(Tween: ITween);
begin
end;

procedure TAbstractTween.DoOverwrite;
begin
end;

procedure TAbstractTween.Play;
begin
  FIsPaused := False;

  if IsCompleted then
    Initialize;

  if not {$IFDEF USECLASSPROPERTY}TTween.{$ENDIF}FList.Contains(Self) then
  begin
    if FOverwrite then
      DoOverwrite;

    {$IFDEF USECLASSPROPERTY}TTween.{$ENDIF}FList.Add(Self);
    AddToPlayList(Self);
  end;
end;

procedure TAbstractTween.Pause;
begin
  FIsPaused := True;
end;

procedure TAbstractTween.Stop;
begin
  FIsPaused := True;

  if {$IFDEF USECLASSPROPERTY}TTween.{$ENDIF}FList.Remove(Self) <> -1 then
  begin
    RemoveFromPlayList(Self);
  end;
end;

function TAbstractTween.Update(const DeltaTime: Cardinal): Cardinal;
begin
  Result := 0;
  if IsPaused or IsCompleted then Exit;

  if DeltaTime > FDuration - FPosition then
    Result := DeltaTime - (FDuration - FPosition);

  Inc(FPosition, DeltaTime);
  if FPosition >= FDuration then
  begin
    FPosition := FDuration;
  end;
  DoUpdate(DeltaTime);
  if Assigned(FOnUpdate) then
    FOnUpdate(Self);
  if IsCompleted and Assigned(FOnComplete) then
    FOnComplete(Self);
end;

procedure TAbstractTween.SetParent(const Value: TAbstractTween);
begin
  if FParent <> nil then
    raise ETweenException.Create('łɕʂɃgDC[Ɋ܂܂Ă܂');

  FParent := Value;
  Stop;
  StopOnComplete := True;
end;

function TAbstractTween.GetPosition: Cardinal;
begin
  Result := FPosition;
end;

function TAbstractTween.GetDuration: Cardinal;
begin
  Result := FDuration;
end;

function TAbstractTween.GetOverwrite: Boolean;
begin
  Result := FOverwrite;
end;

procedure TAbstractTween.SetOverwrite(const Value: Boolean);
begin
  FOverwrite := Value;
end;

function TAbstractTween.GetStopOnComplete: Boolean;
begin
  Result := FStopOnComplete;
end;

procedure TAbstractTween.SetStopOnComplete(const Value: Boolean);
begin
  FStopOnComplete := Value;
end;

function TAbstractTween.GetIsPaused: Boolean;
begin
  if FParent <> nil then
    Result := FParent.IsPaused
  else
    Result := FIsPaused;
end;

function TAbstractTween.GetIsCompleted: Boolean;
begin
  Result := FPosition >= FDuration;
end;

function TAbstractTween.GetOnUpdate: TTweenEventProc;
begin
  Result := FOnUpdate;
end;

procedure TAbstractTween.SetOnUpdate(const Value: TTweenEventProc);
begin
  FOnUpdate := Value;
end;

function TAbstractTween.GetOnComplete: TTweenEventProc;
begin
  Result := FOnComplete;
end;

procedure TAbstractTween.SetOnComplete(const Value: TTweenEventProc);
begin
  FOnComplete := Value;
end;

{ TObjectTween }

function TObjectTween.GetProperty({$IFDEF USERTTI}const RttiType: TRttiType;{$ENDIF}const Obj: TObject; const PropName: string;
  out IsRelative: Boolean; out PropType: TPropType): PPropInfo;
{$IFDEF USERTTI}
var
  prop: TRttiProperty;
{$ENDIF}
begin
  if Obj = nil then
    raise ETweenException.Create('IuWFNgnilł');

{$IFDEF USERTTI}
  IsRelative := Pos('$', PropName) = 1;
  if IsRelative then
    prop := RttiType.GetProperty(Copy(PropName, 2, Length(PropName)))
  else
    prop := RttiType.GetProperty(PropName);

  if prop = nil then
    raise ETweenException.CreateFmt('w肵vpeB܂ (%s)', [PropName]);

  Result := (prop as TRttiInstanceProperty).PropInfo;
{$ELSE}
  IsRelative := Pos('$', PropName) = 1;
  if IsRelative then
    Result := GetPropInfo(Obj, Copy(PropName, 2, Length(PropName)))
  else
    Result := GetPropInfo(Obj, PropName);

  if Result = nil then
    raise ETweenException.CreateFmt('w肵vpeB܂ (%s)', [PropName]);
{$ENDIF}

  if Result.SetProc = nil then
    raise ETweenException.CreateFmt('w肵vpeB͏݂ł܂ (%s)', [PropName]);

  if Result.GetProc = nil then
    raise ETweenException.CreateFmt('w肵vpeB͓ǂݍ݂ł܂ (%s)', [PropName]);

  case Result.PropType^.Kind of
    tkInteger:
    begin
      if Result.PropType^.Name = 'TColor' then
        PropType := ptColor
      else
        PropType := ptInteger;
    end;
    tkFloat:
    begin
      PropType := ptFloat;
    end;
    tkInt64:
    begin
      PropType := ptInt64;
    end;
    else
      raise ETweenException.CreateFmt('%s ^̃vpeB͖Ήł', [Result.PropType^.Name]);
  end;
end;

// Βl擾
function TObjectTween.GetPropAbsoluteValue(const Obj: TObject;
  const Prop: PPropInfo; const BaseValue: TPropValue): TPropValue;
var
  i: Integer;
  color: Integer;
begin
  case Prop.PropType^.Kind of
    tkInteger:
    begin
      if Prop.PropType^.Name = 'TColor' then
      begin
        color := GetOrdProp(Obj, Prop);
        if BaseValue.AsColor = 0 then
        begin
          Result.AsColor := color;
        end
        else begin
          if color < 0 then
            color := GetSysColor(color and $000000FF);
          for i := 0 to 2 do
          begin
            LongRec(Result.AsColor).Bytes[i] := Min(LongRec(color).Bytes[i] + LongRec(BaseValue.AsColor).Bytes[i], 255);
          end;
        end;
      end
      else
        Result.AsInteger := GetOrdProp(Obj, Prop) + BaseValue.AsInteger;
    end;
    tkFloat:
    begin
      Result.AsFloat := GetFloatProp(Obj, Prop) + BaseValue.AsFloat;
    end;
    tkInt64:
    begin
      Result.AsInt64 := GetInt64Prop(Obj, Prop) + BaseValue.AsInt64;
    end;
  end;
end;

constructor TObjectTween.Create(const Obj: TObject;
  const FromValues, ToValues: array of const; const Duration: Cardinal;
  const Easing: IEasing);
var
  i, j: Integer;
{$IFDEF USERTTI}
  ctx: TRttiContext;
  typ: TRttiType;
{$ENDIF}

  function TryGetValue(const Prop: PPropInfo; out Value: TPropValue; out IsRelative: Boolean): Boolean;
  var
    i: Integer;
  begin
    for i := 0 to High(FInitValues) do
      if FInitValues[i].Prop = Prop then
      begin
        Value := FInitValues[i].Value;
        IsRelative := FInitValues[i].IsRelative;
        Result := True;
        Exit;
      end;
    Result := False;
  end;

  function IsStringType(const Value: TVarRec): Boolean;
  begin
    Result := (Value.VType = vtString)
           or (Value.VType = vtPChar)
           or (Value.VType = vtPWideChar)
           or (Value.VType = vtAnsiString)
           or (Value.VType = vtWideString)
           {$IFDEF USEUNICODE}or (Value.VType = vtUnicodeString){$ENDIF};
  end;

  function GetString(const Value: TVarRec): string;
  begin
    case Value.VType of
      vtString: Result := string(Value.VString^);
      vtPChar: Result := string(Value.VPChar);
      vtPWideChar: Result := string(Value.VPWideChar);
      vtAnsiString: Result := string(AnsiString(Value.VAnsiString));
      vtWideString: Result := string(WideString(Value.VWideString));
{$IFDEF USEUNICODE}
      vtUnicodeString: Result := string(UnicodeString(Value.VUnicodeString));
{$ENDIF}
    end;
  end;

  function GetValue(const Value: TVarRec; const PropType: TPropType): TPropValue;
  begin
    case Value.VType of
      vtInteger:
      begin
        case PropType of
          ptInteger: Result.AsInteger := Value.VInteger;
          ptColor: Result.AsColor := Value.VInteger;
          ptFloat: Result.AsFloat := Value.VInteger;
          ptInt64: Result.AsInt64 := Value.VInteger;
        end;
      end;
      vtExtended:
      begin
        case PropType of
          ptInteger: Result.AsInteger := Trunc(Value.VExtended^);
          ptColor: Result.AsColor := Trunc(Value.VExtended^);
          ptFloat: Result.AsFloat := Value.VExtended^;
          ptInt64: Result.AsInt64 := Trunc(Value.VExtended^);
        end;
      end;
      vtInt64:
      begin
        case PropType of
          ptInteger: Result.AsInteger := Value.VInt64^;
          ptColor: Result.AsColor := Value.VInt64^;
          ptFloat: Result.AsFloat := Value.VInt64^;
          ptInt64: Result.AsInt64 := Value.VInt64^;
        end;
      end;
    end;
  end;

begin
  inherited Create;

  if Duration = 0 then
    raise ETweenException.Create('Durationɂ̓[傫lw肵ĉ');

  if Odd(Length(FromValues)) then
    raise ETweenException.Create('FromValuesɂ̓vpeBƒl̃yAw肵ĉ');

  if Odd(Length(ToValues)) then
    raise ETweenException.Create('ToValuesɂ̓vpeBƒl̃yAw肵ĉ');

  if (Length(FromValues) = 0) and (Length(ToValues) = 0) then
    raise ETweenException.Create('FromValuesToValues̗A邢͂ꂩЕ1ȏ̃vpeBƒl̃yAw肵ĉ');

  // Ƀ`FbNႤ
  i := 0;
  while i < Length(FromValues) do
  begin
    if not IsStringType(FromValues[i]) then
      raise ETweenException.CreateFmt('FromValues%dԖڂ̈ɂ͕^̒lw肵ĉ', [i]);
    if not (FromValues[i+1].VType in [vtInteger, vtExtended, vtInt64]) then
      raise ETweenException.CreateFmt('FromValues%dԖڂ̈ɂ͐^A܂͎^̒lw肵ĉ', [i+1]);
    Inc(i, 2);
  end;

  i := 0;
  while i < Length(ToValues) do
  begin
    if not IsStringType(ToValues[i]) then
      raise ETweenException.CreateFmt('FromValues%dԖڂ̈ɂ͕^̒lw肵ĉ', [i]);
    if not (ToValues[i+1].VType in [vtInteger, vtExtended, vtInt64]) then
      raise ETweenException.CreateFmt('FromValues%dԖڂ̈ɂ͐^A܂͎^̒lw肵ĉ', [i+1]);
    Inc(i, 2);
  end;

{$IFDEF USERTTI}
  ctx := TRttiContext.Create;
  typ := ctx.GetType(Obj.ClassType);
  if typ = nil then
    raise ETweenException.CreateFmt('%s ̌^擾ł܂', [Obj.ClassName]);
{$ENDIF}

  FIsValueFixed := False;

  i := 0; j := 0;

  // FromValuesw肳ĂȂꍇToValues̃vpeB̌ݒlݒ
  if Length(FromValues) = 0 then
  begin
    SetLength(FInitValues, Length(ToValues) div 2);
    while i < Length(ToValues) do
    begin
      with FInitValues[j] do
      begin
        Prop := GetProperty({$IFDEF USERTTI}typ,{$ENDIF}Obj, GetString(ToValues[i]), IsRelative, PropType);
        IsRelative := True;
        FillChar(Value, SizeOf(Value), 0);
      end;
      Inc(i, 2);
      Inc(j);
    end;
  end
  else begin
    SetLength(FInitValues, Length(FromValues) div 2);
    while i < Length(FromValues) do
    begin
      with FInitValues[j] do
      begin
        Prop := GetProperty({$IFDEF USERTTI}typ,{$ENDIF}Obj, GetString(FromValues[i]), IsRelative, PropType);
        Value := GetValue(FromValues[i+1], PropType);
      end;
      Inc(i, 2);
      Inc(j);
    end;
  end;

  i := 0; j := 0;

  // ToValuesw肳ĂȂꍇFromValues̃vpeB̌ݒlݒ
  if Length(ToValues) = 0 then
  begin
    SetLength(FChangeValues, Length(FromValues) div 2);
    while i < Length(FromValues) do
    begin
      with FChangeValues[j] do
      begin
        Prop := GetProperty({$IFDEF USERTTI}typ,{$ENDIF}Obj, GetString(FromValues[i]), IsRelative, PropType);
        IsRelative := True;
        BaseValue := GetValue(FromValues[i+1], PropType);
        FillChar(FinishValue, SizeOf(FinishValue), 0);
      end;
      Inc(i, 2);
      Inc(j)
    end;
  end
  else begin
    SetLength(FChangeValues, Length(ToValues) div 2);
    while i < Length(ToValues) do
    begin
      with FChangeValues[j] do
      begin
        Prop := GetProperty({$IFDEF USERTTI}typ,{$ENDIF}Obj, GetString(ToValues[i]), IsRelative, PropType);
        FinishValue := GetValue(ToValues[i+1], PropType);
      end;
      Inc(i, 2);
      Inc(j);
    end;
  end;

  FObj := Obj;
  FDuration := Duration;
  FPosition := FDuration;
  if Assigned(Easing) then
    FEasing := Easing
  else
    FEasing := TEasing.Linear;
end;

{ Βl̎s擾ƍvZ }
procedure TObjectTween.CalcValues;
var
  i, j: Integer;
  color: Integer;

  function TryGetInitValue(const Prop: PPropInfo; out Value: TPropValue): Boolean;
  var
    i: Integer;
  begin
    for i := 0 to High(FInitValues) do
      if FInitValues[i].Prop = Prop then
      begin
        Value := FInitValues[i].Value;
        Result := True;
        Exit;
      end;
    Result := False;
  end;

begin
  for i := Low(FInitValues) to High(FInitValues) do
  begin
    with FInitValues[i] do
      if IsRelative then
        Value := GetPropAbsoluteValue(FObj, Prop, Value);
  end;

  for i := Low(FChangeValues) to High(FChangeValues) do
  begin
    with FChangeValues[i] do
    begin
      if not TryGetInitValue(Prop, BaseValue) then
      begin
        case PropType of
          ptInteger: BaseValue.AsInteger := GetOrdProp(FObj, Prop);
          ptColor: BaseValue.AsColor := GetOrdProp(FObj, Prop);
          ptFloat: BaseValue.AsFloat := GetFloatProp(FObj, Prop);
          ptInt64: BaseValue.AsInt64 := GetInt64Prop(FObj, Prop);
        end;
      end;

      if IsRelative then
        FinishValue := GetPropAbsoluteValue(FObj, Prop, FinishValue);

      // vZ
      case PropType of
        ptInteger: DiffValue.AsInteger := FinishValue.AsInteger - BaseValue.AsInteger;
        ptColor:
        begin
          if BaseValue.AsColor < 0 then
            BaseValue.AsColor := GetSysColor(BaseValue.AsColor and $000000FF);
          color := FinishValue.AsColor;
          if color < 0 then
            color := GetSysColor(color and $000000FF);
          for j := 0 to 2 do
            DiffValue.AsColor[j] := LongRec(color).Bytes[j] - LongRec(BaseValue.AsColor).Bytes[j];
        end;
        ptFloat:
        begin
          DiffValue.AsFloat := FinishValue.AsFloat - BaseValue.AsFloat;
        end;
        ptInt64:
        begin
          DiffValue.AsInt64 := FinishValue.AsInt64 - BaseValue.AsInt64;
        end;
      end;
    end;
  end;

  FIsValueFixed := True;
end;

procedure TObjectTween.AddToPlayList(Tween: ITween);
begin
  TTween.AddToPlayList(FObj, Tween);
end;

procedure TObjectTween.RemoveFromPlayList(Tween: ITween);
begin
  TTween.RemoveFromPlayList(FObj, Tween);
end;

procedure TObjectTween.DoOverwrite;
begin
  TTween.Abort(FObj);
end;

procedure TObjectTween.Initialize;
var
  i: Integer;
begin
  if not FIsValueFixed then
    CalcValues;

  FPosition := 0;
  for i := 0 to High(FInitValues) do
    with FInitValues[i] do
      case PropType of
        ptInteger: SetOrdProp(FObj, Prop, Value.AsInteger);
        ptColor: SetOrdProp(FObj, Prop, FInitValues[i].Value.AsColor);
        ptFloat: SetFloatProp(FObj, Prop, Value.AsFloat);
        ptInt64: SetInt64Prop(FObj, Prop, Value.AsInt64);
      end;
end;

procedure TObjectTween.DoUpdate(const DeltaTime: Cardinal);

  function RoundOff(const Value: Extended): Int64; {$IFDEF USEINLINE}inline;{$ENDIF}
  begin
    if Value >= 0 then Result := Trunc(Value + 0.5)
    else Result := Trunc(Value - 0.5);
  end;

var
  i, j: Integer;
  value: Integer;
begin
  if IsCompleted then
  begin
    for i := 0 to High(FChangeValues) do
      with FChangeValues[i] do
        case PropType of
          ptInteger: SetOrdProp(FObj, Prop, FinishValue.AsInteger);
          ptColor: SetOrdProp(FObj, Prop, FinishValue.AsColor);
          ptFloat: SetFloatProp(FObj, Prop, FinishValue.AsFloat);
          ptInt64: SetInt64Prop(FObj, Prop, FinishValue.AsInt64);
        end;
    Exit;
  end;

  for i := 0 to High(FChangeValues) do
  begin
    with FChangeValues[i] do
    begin
      case PropType of
        ptInteger: SetOrdProp(FObj, Prop, RoundOff(FEasing.Calculate(FPosition, BaseValue.AsInteger, DiffValue.AsInteger, FDuration)));
        ptColor:
        begin
          value := 0;
          for j := 0 to 2 do
            LongRec(value).Bytes[j] := RoundOff(FEasing.Calculate(FPosition, Longrec(BaseValue.AsColor).Bytes[j], DiffValue.AsColor[j], FDuration));
          SetOrdProp(FObj, Prop, value);
        end;
        ptFloat: SetFloatProp(FObj, Prop, FEasing.Calculate(FPosition, BaseValue.AsFloat, DiffValue.AsFloat, FDuration));
        ptInt64: SetInt64Prop(FObj, Prop, RoundOff(FEasing.Calculate(FPosition, BaseValue.AsInt64, DiffValue.AsInt64, FDuration)));
      end;
    end;
  end;
end;

{ TGroupTween }

constructor TWrapTween.Create(const Tweens: array of ITween);
var
  i: Integer;
begin
  if Length(Tweens) = 0 then
    raise ETweenException.Create('1ȏITweenw肵ĉ');

  inherited Create;

  FDuration := 0;
  SetLength(FTweens, Length(Tweens));
  for i := Low(FTweens) to High(FTweens) do
  begin
    if Tweens[i] = nil then
      raise ETweenException.CreateFmt('nil͎wł܂ (Tweens[%d] = nil)', [i]);

    FTweens[i] := Tweens[i];
    TAbstractTween(IntfAsObj(FTweens[i])).Parent := Self;
  end;
end;

constructor TWrapTween.Create(const BaseTween: ITween);
begin
  Create([BaseTween]);
end;

procedure TWrapTween.AddToPlayList(Tween: ITween);
var
  i: Integer;
begin
  for i := Low(FTweens) to High(FTweens) do
    TAbstractTween(IntfAsObj(FTweens[i])).AddToPlayList(Tween);
end;

procedure TWrapTween.RemoveFromPlayList(Tween: ITween);
var
  i: Integer;
begin
  for i := Low(FTweens) to High(FTweens) do
    TAbstractTween(IntfAsObj(FTweens[i])).RemoveFromPlayList(Tween);
end;

procedure TWrapTween.DoOverwrite;
var
  i: Integer;
begin
  for i := Low(FTweens) to High(FTweens) do
    TAbstractTween(IntfAsObj(FTweens[i])).DoOverwrite;
end;

function TWrapTween.GetBaseTween: ITween;
begin
  Result := FTweens[0];
end;

{ TParallelTween }

constructor TParallelTween.Create(const Tweens: array of ITween);
var
  i: Integer;
begin
  inherited;
  for i := Low(FTweens) to High(FTweens) do
    if FTweens[i].Duration > FDuration then
      FDuration := FTweens[i].Duration;
  FPosition := FDuration;
end;

procedure TParallelTween.Initialize;
var
  i: Integer;
begin
  FPosition := 0;
  for i := Low(FTweens) to High(FTweens) do
    FTweens[i].Initialize;
end;

procedure TParallelTween.DoUpdate(const DeltaTime: Cardinal);
var
  i: Integer;
begin
  for i := Low(FTweens) to High(FTweens) do
    FTweens[i].Update(DeltaTime);
end;

{ TSerialTween }

constructor TSerialTween.Create(const Tweens: array of ITween);
var
  i: Integer;
begin
  inherited;
  for i := Low(FTweens) to High(FTweens) do
    Inc(FDuration, FTweens[i].Duration);
  FPosition := FDuration;
end;

procedure TSerialTween.Initialize;
begin
  FPosition := 0;
  FTweenIndex := 0;
  if Length(FTweens) <> 0 then
    FTweens[FTweenIndex].Initialize;
end;

procedure TSerialTween.DoUpdate(const DeltaTime: Cardinal);
var
  d: Cardinal;
begin
  if (FTweenIndex < Low(FTweens)) or (FTweenIndex > High(FTweens)) then Exit;

  d := FTweens[FTweenIndex].Update(DeltaTime);
  while FTweens[FTweenIndex].IsCompleted do
  begin
    Inc(FTweenIndex);
    if FTweenIndex > High(FTweens) then Break;
    FTweens[FTweenIndex].Initialize; // [t1, t1]ƓTweenw肳ꂽꍇpɕK{
    if d = 0 then Break;
    d := FTweens[FTweenIndex].Update(d);
  end;
end;

{ TDelayedTween }

constructor TDelayedTween.Create(const PreDelay, PostDelay: Cardinal; const BaseTween: ITween);
begin
  if BaseTween = nil then
    raise ETweenException.Create('fBCΏۂITweenɂnilwł܂');

  inherited Create(BaseTween);

  FPreDelay := PreDelay;
  FPostDelay := PostDelay;;
  FDuration := FPreDelay + BaseTween.Duration + FPostDelay;
  FPosition := FDuration;
end;

procedure TDelayedTween.Initialize;
begin
  FPosition := 0;
  FState := Pre;
end;

procedure TDelayedTween.DoUpdate(const DeltaTime: Cardinal);
begin
  case FState of
    Pre:
    begin
      if FPosition >= FPreDelay then
      begin
        BaseTween.Initialize;
        BaseTween.Update(FPosition - FPreDelay);
        FState := Proc;
      end;
    end;
    Proc:
    begin
      BaseTween.Update(DeltaTime);
      if BaseTween.IsCompleted then
        FState := Post;
    end;
    Post: ;
  end;
end;

{ TCycledTween }

constructor TCycledTween.Create(const CycleCount: Cardinal;
  const BaseTween: ITween);
begin
  if BaseTween = nil then
    raise ETweenException.Create('fBCΏۂITweenɂnilwł܂');

  inherited Create(BaseTween);

  FCurrentCount := 0;
  FCycleCount := CycleCount;
  FDuration := BaseTween.Duration * FCycleCount;
  FPosition := FDuration;
end;

procedure TCycledTween.Initialize;
begin
  FPosition := 0;
  FCurrentCount := 0;
  BaseTween.Initialize;
end;

procedure TCycledTween.DoUpdate(const DeltaTime: Cardinal);
var
  d: Cardinal;
begin
  d := BaseTween.Update(DeltaTime);
  while BaseTween.IsCompleted do
  begin
    Inc(FCurrentCount);
    if FCurrentCount >= FCycleCount then Break;
    BaseTween.Initialize;
    if d = 0 then Break;
    d := BaseTween.Update(d);
  end;
end;

{ TTween }

class procedure TTween.ListNotify(Sender: TObject; const Item: ITween;
  Action: TCollectionNotification);
begin
  case Action of
    cnAdded:
    begin
      if FList.Count = 1 then
        StartTimer;
    end;
    cnRemoved, cnExtracted:
    begin
      if FList.Count = 0 then
        ClearTimer;
    end;
  end;
end;

{$IFDEF USECLASSSYNCHRONIZE}
procedure TimerProc(uTimerID, uMessage: UINT; dwUser, dw1, dw2: DWORD); stdcall;
begin
  TThread.Synchronize(nil, TTween.Update);
end;
{$ELSE}
class procedure TTween.OnTimer(Sender: TObject);
begin
  TTween.Update;
end;
{$ENDIF}

class procedure TTween.StartTimer;
begin
  if not FAutoUpdate then Exit;
  ClearTimer;
  if FList.Count = 0 then Exit;
  FPrevTime := timeGetTime;
{$IFDEF USECLASSSYNCHRONIZE}
  FTimerId := timeSetEvent(1000 div FSpeed, 1, TimerProc, 0, TIME_PERIODIC);
{$ELSE}
  FTimer.Interval := 1000 div FSpeed;
  FTimer.Enabled := True;
{$ENDIF}
end;

class procedure TTween.ClearTimer;
begin
{$IFDEF USECLASSSYNCHRONIZE}
  if FTimerId <> 0 then
  begin
    timeKillEvent(FTimerId);
    FTimerId := 0;
  end;
{$ELSE}
  FTimer.Enabled := False;
{$ENDIF}
end;

class procedure TTween.Abort(Obj: TObject = nil);
var
  i: Integer;
  list: TTweenList;
begin
  if Obj = nil then
  begin
    while FList.Count > 0 do
      FList[0].Stop;
  end
  else begin
    if FObjTweens.TryGetValue(Obj, list) then
    begin
      for i := 0 to list.Count-1 do
      begin
        TAbstractTween(IntfAsObj(list[i])).Stop;
      end;
      FObjTweens.Remove(Obj);
    end;
  end;
end;

class procedure TTween.AddToPlayList(Obj: TObject; Tween: ITween);
var
  list: TTweenList;
begin
  if not FObjTweens.ContainsKey(Obj) then
  begin
    list := TTweenList.Create;
    list.Add(Tween);
    FObjTweens.Add(Obj, list);
  end
  else begin
    list := FObjTweens[Obj];
    if not list.Contains(Tween) then
      list.Add(Tween);
  end;
end;

class procedure TTween.RemoveFromPlayList(Obj: TObject; Tween: ITween);
var
  list: TTweenList;
begin
  if not FObjTweens.TryGetValue(Obj, list) then Exit;
  if list.Remove(Tween) = -1 then Exit;
  if list.Count <> 0 then Exit;
  FObjTweens.Remove(Obj);
end;

class procedure TTween.Update;
var
  i: Integer;
  curTime: Cardinal;
  delta: Cardinal;
begin
  if Assigned(FOnBeforeUpdate) then
    FOnBeforeUpdate;

  i := 0;
  curTime := timeGetTime;
  delta := curTime - FPrevTime;
  while i < FList.Count do
  begin
    FList[i].Update(delta);
    if FList[i].IsCompleted then
    begin
      if FList[i].StopOnComplete then
      begin
        FList[i].Stop;
      end
      else begin
        FList[i].Initialize;
        Inc(i);
      end;
    end
    else begin
      Inc(i);
    end;
  end;
  FPrevTime := curTime;

  if Assigned(FOnAfterUpdate) then
    FOnAfterUpdate;
end;

type
  TTweenArray = array of ITween;

  TArrayHelper = class
  public
    class procedure Add(var Values: TTweenArray; const Item: ITween);
  end;

class procedure TArrayHelper.Add(var Values: TTweenArray; const Item: ITween);
begin
  SetLength(Values, Length(Values)+1);
  Values[High(Values)] := Item;
end;

class function TTween.Tween(const Obj: TObject; const FromValues, ToValues: array of const;
  const Duration: Cardinal; const Easing: IEasing): ITween;
begin
  Result := TObjectTween.Create(Obj, FromValues, ToValues, Duration, Easing);
end;

class function TTween.Tween(const Objs: array of TObject; const FromValues,
  ToValues: array of const; const Duration: Cardinal;
  const Easing: IEasing): ITween;
var
  i: Integer;
  tweens: TTweenArray;
begin
  for i := Low(Objs) to High(Objs) do
  begin
    TArrayHelper.Add(tweens, TTween.Tween(Objs[i], FromValues, ToValues, Duration, Easing));
  end;
  Result := TParallelTween.Create(tweens);
end;

class function TTween.TweenTo(Obj: TObject; const ToValues: array of const;
  Duration: Cardinal; const Easing: IEasing): ITween;
begin
  Result := Tween(Obj, [], ToValues, Duration, Easing);
end;

class function TTween.TweenTo(const Objs: array of TObject;
  const ToValues: array of const; Duration: Cardinal;
  const Easing: IEasing): ITween;
begin
  Result := Tween(Objs, [], ToValues, Duration, Easing);
end;

class function TTween.TweenFrom(Obj: TObject; const FromValues: array of const;
  Duration: Cardinal; const Easing: IEasing): ITween;
begin
  Result := Tween(Obj, FromValues, [], Duration, Easing);
end;

class function TTween.TweenFrom(const Objs: array of TObject;
  const FromValues: array of const; Duration: Cardinal;
  const Easing: IEasing): ITween;
begin
  Result := Tween(Objs, FromValues, [], Duration, Easing);
end;

class function TTween.Parallel(const Tweens: array of ITween): ITween;
begin
  Result := TParallelTween.Create(Tweens);
end;

class function TTween.Serial(const Tweens: array of ITween): ITween;
begin
  Result := TSerialTween.Create(Tweens);
end;

class function TTween.Delay(const PreDelay, PostDelay: Cardinal;
  const BaseTween: ITween): ITween;
begin
  Result := TDelayedTween.Create(PreDelay, PostDelay, BaseTween);
end;

class function TTween.Cycle(const CycleCount: Cardinal;
  const BaseTween: ITween): ITween;
begin
  Result := TCycledTween.Create(CycleCount, BaseTween);
end;

{$IFDEF USECLASSPROPERTY}
class procedure TTween.SetAutoUpdate(const Value: Boolean);
begin
  if FAutoUpdate = Value then Exit;
  FAutoUpdate := Value;
  if FAutoUpdate then
  begin
    TTween.StartTimer;
  end
  else begin
    TTween.ClearTimer;
  end;
end;

class procedure TTween.SetSpeed(const Value: Cardinal);
begin
  if FSpeed = Value then Exit;
  if (Value < 1) or (Value > 1000) then
    raise ETweenException.CreateFmt('Speed1`1000͈̔͂Ŏw肵ĉ (%d)', [Value]);
  FSpeed := Value;
  if not FAutoUpdate then Exit;
  StartTimer;
end;
{$ENDIF}

initialization
{$IFDEF USECLASSPROPERTY}with TTween do begin{$ENDIF}
  FList := TTweenList.Create;
  FList.OnNotify := TTween.ListNotify;
  FObjTweens := TObjectTweenDictionary.Create;
  timeBeginPeriod(1);
  FDefaultOverwrite := True;
  FAutoUpdate := True;
  FSpeed := DEFAULT_SPEED;
{$IFNDEF USECLASSSYNCHRONIZE}
  FTimer := TTimer.Create(nil);
  FTimer.Enabled := False;
  FTimer.OnTimer := TTween.OnTimer;
{$ENDIF}
{$IFDEF USECLASSPROPERTY}end;{$ENDIF}
finalization
  TTween.ClearTimer;
  timeEndPeriod(1);
{$IFDEF USECLASSPROPERTY}with TTween do begin{$ENDIF}
  FObjTweens.Free;
  FList.Free;
{$IFNDEF USECLASSSYNCHRONIZE}
  FTimer.Free;
{$ENDIF}
{$IFDEF USECLASSPROPERTY}end;{$ENDIF}
end.
